import * as react_jsx_runtime from 'react/jsx-runtime';
import { ReactNode, ComponentProps, ComponentType } from 'react';
import { P as PropsWithoutChildren } from './PropsWithoutChildren-B-UcudRB.cjs';

interface ClientOnlyProps {
    children: ReactNode;
    fallback?: ReactNode;
}
/**
 * This component ensures its children are only rendered on the client-side.
 * @see {@link https://suspensive.org/docs/react/ClientOnly Suspensive Docs}
 */
declare const ClientOnly: (({ children, fallback }: ClientOnlyProps) => react_jsx_runtime.JSX.Element) & {
    displayName: string;
    with: <TProps extends ComponentProps<ComponentType> = Record<string, never>>(clientOnlyProps: PropsWithoutChildren<ClientOnlyProps>, Component: ComponentType<TProps>) => ((props: TProps) => react_jsx_runtime.JSX.Element) & {
        displayName: string;
    };
};

export { ClientOnly, type ClientOnlyProps };
