"use client"
import {
  Message_useErrorBoundaryGroup_this_hook_should_be_called_in_ErrorBoundary_props_children,
  SuspensiveError
} from "./chunk-NF2UFYHD.js";
import {
  increase
} from "./chunk-RRCSTSER.js";
import {
  useIsChanged
} from "./chunk-XMHMZEKB.js";
import {
  __spreadProps,
  __spreadValues
} from "./chunk-HVDFXOFP.js";

// src/ErrorBoundaryGroup.tsx
import {
  createContext,
  useContext,
  useEffect,
  useMemo,
  useReducer
} from "react";
import { Fragment, jsx } from "react/jsx-runtime";
var ErrorBoundaryGroupContext = createContext(void 0);
if (process.env.NODE_ENV === "development") {
  ErrorBoundaryGroupContext.displayName = "ErrorBoundaryGroupContext";
}
var ErrorBoundaryGroup = Object.assign(
  ({ blockOutside = false, children }) => {
    const [resetKey, reset] = useReducer(increase, 0);
    const parentGroup = useContext(ErrorBoundaryGroupContext);
    const isParentGroupResetKeyChanged = useIsChanged(parentGroup == null ? void 0 : parentGroup.resetKey);
    useEffect(() => {
      if (!blockOutside && isParentGroupResetKeyChanged) {
        reset();
      }
    }, [isParentGroupResetKeyChanged, blockOutside]);
    const value = useMemo(() => ({ reset, resetKey }), [resetKey]);
    return /* @__PURE__ */ jsx(ErrorBoundaryGroupContext.Provider, { value, children });
  },
  {
    displayName: "ErrorBoundaryGroup",
    with: (errorBoundaryGroupProps = {}, Component) => Object.assign(
      (props) => /* @__PURE__ */ jsx(ErrorBoundaryGroup, __spreadProps(__spreadValues({}, errorBoundaryGroupProps), { children: /* @__PURE__ */ jsx(Component, __spreadValues({}, props)) })),
      { displayName: "ErrorBoundaryGroup.with(".concat(Component.displayName || Component.name || "Component", ")") }
    ),
    Consumer: ({
      children
    }) => /* @__PURE__ */ jsx(Fragment, { children: children(useErrorBoundaryGroup()) })
  }
);
var useErrorBoundaryGroup = () => {
  const group = useContext(ErrorBoundaryGroupContext);
  SuspensiveError.assert(
    group != null,
    Message_useErrorBoundaryGroup_this_hook_should_be_called_in_ErrorBoundary_props_children
  );
  return useMemo(
    () => ({
      /**
       * When you want to reset multiple ErrorBoundaries as children of ErrorBoundaryGroup, You can use this reset
       */
      reset: group.reset
    }),
    [group.reset]
  );
};

export {
  ErrorBoundaryGroupContext,
  ErrorBoundaryGroup,
  useErrorBoundaryGroup
};
//# sourceMappingURL=chunk-X5J3NNMT.js.map