"use client"
"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  ClientOnly: () => ClientOnly,
  DefaultProps: () => DefaultProps,
  DefaultPropsProvider: () => DefaultPropsProvider,
  Delay: () => Delay,
  ErrorBoundary: () => ErrorBoundary,
  ErrorBoundaryGroup: () => ErrorBoundaryGroup,
  Suspense: () => Suspense2,
  useErrorBoundary: () => useErrorBoundary,
  useErrorBoundaryFallbackProps: () => useErrorBoundaryFallbackProps,
  useErrorBoundaryGroup: () => useErrorBoundaryGroup
});
module.exports = __toCommonJS(index_exports);

// src/contexts/DefaultPropsContexts.ts
var import_react = require("react");
var DelayDefaultPropsContext = Object.assign(
  (0, import_react.createContext)({ ms: void 0, fallback: void 0 }),
  { displayName: "DelayDefaultPropsContext" }
);
var SuspenseDefaultPropsContext = Object.assign(
  (0, import_react.createContext)({ fallback: void 0, clientOnly: void 0 }),
  { displayName: "SuspenseDefaultPropsContext" }
);

// src/models/SuspensiveError.ts
var SuspensiveError = class _SuspensiveError extends Error {
  static assert(condition, message) {
    if (!condition) {
      throw new _SuspensiveError(message);
    }
  }
};
var Message_useErrorBoundary_this_hook_should_be_called_in_ErrorBoundary_props_children = "useErrorBoundary: this hook should be called in ErrorBoundary.props.children";
var Message_useErrorBoundaryFallbackProps_this_hook_should_be_called_in_ErrorBoundary_props_fallback = "useErrorBoundaryFallbackProps: this hook should be called in ErrorBoundary.props.fallback";
var Message_useErrorBoundaryGroup_this_hook_should_be_called_in_ErrorBoundary_props_children = "useErrorBoundaryGroup: this hook should be called in ErrorBoundary.props.children";
var Message_Delay_ms_prop_should_be_greater_than_or_equal_to_0 = "Delay: ms prop should be greater than or equal to 0";
var Message_DefaultProp_delay_ms_should_be_greater_than_0 = "DefaultProps: delay.ms should be greater than 0";

// src/DefaultProps.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var DefaultProps = class {
  constructor(defaultProps = {}) {
    var _a;
    if (process.env.NODE_ENV === "development" && typeof ((_a = defaultProps.Delay) == null ? void 0 : _a.ms) === "number") {
      SuspensiveError.assert(defaultProps.Delay.ms > 0, Message_DefaultProp_delay_ms_should_be_greater_than_0);
    }
    this.Suspense = defaultProps.Suspense;
    this.Delay = defaultProps.Delay;
  }
};
var DefaultPropsProvider = ({ defaultProps, children }) => {
  var _a, _b;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(DelayDefaultPropsContext.Provider, { value: (_a = defaultProps.Delay) != null ? _a : {}, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(SuspenseDefaultPropsContext.Provider, { value: (_b = defaultProps.Suspense) != null ? _b : {}, children }) });
};

// src/Suspense.tsx
var import_react6 = require("react");

// src/utils/hasResetKeysChanged.ts
var hasResetKeysChanged = (a = [], b = []) => a.length !== b.length || a.some((item, index) => !Object.is(item, b[index]));

// src/utils/defineSuspense.tsx
var import_react5 = require("react");

// src/hooks/usePrevious.ts
var import_react2 = require("react");
var usePrevious = (value) => {
  const ref = (0, import_react2.useRef)(value);
  (0, import_react2.useEffect)(() => {
    ref.current = value;
  }, [value]);
  return ref.current;
};

// src/hooks/useIsChanged.ts
var useIsChanged = (value) => usePrevious(value) !== value;

// src/hooks/useIsClient.ts
var import_react3 = require("react");

// src/utils/noop.ts
var noop = () => {
};

// src/hooks/useIsClient.ts
var emptySubscribe = () => noop;
var getSnapshot = () => true;
var getServerSnapshot = () => false;
var useIsClient = () => (0, import_react3.useSyncExternalStore)(emptySubscribe, getSnapshot, getServerSnapshot);

// src/hooks/useTimeout.ts
var import_react4 = require("react");
var useTimeout = (fn, ms) => {
  const fnRef = (0, import_react4.useRef)(fn);
  fnRef.current = fn;
  const fnPreserved = (0, import_react4.useCallback)(() => fnRef.current(), []);
  (0, import_react4.useEffect)(() => {
    const id = setTimeout(fnPreserved, ms);
    return () => clearTimeout(id);
  }, [fnPreserved, ms]);
};

// src/ClientOnly.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var ClientOnly = Object.assign(
  ({ children, fallback }) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: useIsClient() ? children : fallback }),
  {
    displayName: "ClientOnly",
    with: (clientOnlyProps, Component2) => Object.assign(
      (props) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(ClientOnly, __spreadProps(__spreadValues({}, clientOnlyProps), { children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Component2, __spreadValues({}, props)) })),
      { displayName: "".concat(ClientOnly.displayName, ".with(").concat(Component2.displayName || Component2.name || "Component", ")") }
    )
  }
);

// src/utils/defineSuspense.tsx
var import_jsx_runtime3 = require("react/jsx-runtime");
var SuspenseClientOnly = (props) => /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(ClientOnly, { fallback: props.fallback, children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_react5.Suspense, __spreadValues({}, props)) });
function defineSuspense({
  defaultPropsClientOnly,
  componentPropsClientOnly
}) {
  return (componentPropsClientOnly != null ? componentPropsClientOnly : defaultPropsClientOnly) ? SuspenseClientOnly : import_react5.Suspense;
}

// src/utils/increase.ts
var increase = (prev) => prev + 1;

// src/Suspense.tsx
var import_jsx_runtime4 = require("react/jsx-runtime");
var Suspense2 = Object.assign(
  ({ clientOnly, children, fallback }) => {
    const defaultProps = (0, import_react6.useContext)(SuspenseDefaultPropsContext);
    const DefinedSuspense = defineSuspense({
      defaultPropsClientOnly: defaultProps.clientOnly,
      componentPropsClientOnly: clientOnly
    });
    return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(DefinedSuspense, { fallback: fallback === void 0 ? defaultProps.fallback : fallback, children });
  },
  {
    displayName: "Suspense",
    with: (suspenseProps = {}, Component2) => Object.assign(
      (props) => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(Suspense2, __spreadProps(__spreadValues({}, suspenseProps), { children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(Component2, __spreadValues({}, props)) })),
      { displayName: "Suspense.with(".concat(Component2.displayName || Component2.name || "Component", ")") }
    )
  }
);

// src/ErrorBoundary.tsx
var import_react8 = require("react");

// src/ErrorBoundaryGroup.tsx
var import_react7 = require("react");
var import_jsx_runtime5 = require("react/jsx-runtime");
var ErrorBoundaryGroupContext = (0, import_react7.createContext)(void 0);
if (process.env.NODE_ENV === "development") {
  ErrorBoundaryGroupContext.displayName = "ErrorBoundaryGroupContext";
}
var ErrorBoundaryGroup = Object.assign(
  ({ blockOutside = false, children }) => {
    const [resetKey, reset] = (0, import_react7.useReducer)(increase, 0);
    const parentGroup = (0, import_react7.useContext)(ErrorBoundaryGroupContext);
    const isParentGroupResetKeyChanged = useIsChanged(parentGroup == null ? void 0 : parentGroup.resetKey);
    (0, import_react7.useEffect)(() => {
      if (!blockOutside && isParentGroupResetKeyChanged) {
        reset();
      }
    }, [isParentGroupResetKeyChanged, blockOutside]);
    const value = (0, import_react7.useMemo)(() => ({ reset, resetKey }), [resetKey]);
    return /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(ErrorBoundaryGroupContext.Provider, { value, children });
  },
  {
    displayName: "ErrorBoundaryGroup",
    with: (errorBoundaryGroupProps = {}, Component2) => Object.assign(
      (props) => /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(ErrorBoundaryGroup, __spreadProps(__spreadValues({}, errorBoundaryGroupProps), { children: /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(Component2, __spreadValues({}, props)) })),
      { displayName: "ErrorBoundaryGroup.with(".concat(Component2.displayName || Component2.name || "Component", ")") }
    ),
    Consumer: ({
      children
    }) => /* @__PURE__ */ (0, import_jsx_runtime5.jsx)(import_jsx_runtime5.Fragment, { children: children(useErrorBoundaryGroup()) })
  }
);
var useErrorBoundaryGroup = () => {
  const group = (0, import_react7.useContext)(ErrorBoundaryGroupContext);
  SuspensiveError.assert(
    group != null,
    Message_useErrorBoundaryGroup_this_hook_should_be_called_in_ErrorBoundary_props_children
  );
  return (0, import_react7.useMemo)(
    () => ({
      /**
       * When you want to reset multiple ErrorBoundaries as children of ErrorBoundaryGroup, You can use this reset
       */
      reset: group.reset
    }),
    [group.reset]
  );
};

// src/ErrorBoundary.tsx
var import_jsx_runtime6 = require("react/jsx-runtime");
var checkErrorBoundary = (shouldCatch, error) => {
  if (typeof shouldCatch === "boolean") {
    return shouldCatch;
  }
  if (shouldCatch.prototype instanceof Error) {
    return error instanceof shouldCatch;
  }
  return shouldCatch(error);
};
var initialErrorBoundaryState = {
  isError: false,
  error: null
};
var BaseErrorBoundary = class extends import_react8.Component {
  constructor() {
    super(...arguments);
    this.state = initialErrorBoundaryState;
    this.reset = () => {
      var _a, _b;
      (_b = (_a = this.props).onReset) == null ? void 0 : _b.call(_a);
      this.setState(initialErrorBoundaryState);
    };
  }
  static getDerivedStateFromError(error) {
    return { isError: true, error };
  }
  componentDidUpdate(prevProps, prevState) {
    const { isError } = this.state;
    const { resetKeys } = this.props;
    if (isError && prevState.isError && hasResetKeysChanged(prevProps.resetKeys, resetKeys)) {
      this.reset();
    }
  }
  componentDidCatch(error, info) {
    var _a, _b;
    (_b = (_a = this.props).onError) == null ? void 0 : _b.call(_a, error, info);
  }
  render() {
    const { children, fallback, shouldCatch = true } = this.props;
    const { isError, error } = this.state;
    let childrenOrFallback = children;
    if (isError) {
      if (error instanceof SuspensiveError) {
        throw error;
      }
      if (error instanceof ErrorInFallback) {
        throw error.originalError;
      }
      const isCatch = Array.isArray(shouldCatch) ? shouldCatch.some((shouldCatch2) => checkErrorBoundary(shouldCatch2, error)) : checkErrorBoundary(shouldCatch, error);
      if (!isCatch) {
        throw error;
      }
      if (typeof fallback === "undefined") {
        if (process.env.NODE_ENV === "development") {
          console.error("ErrorBoundary of @suspensive/react requires a defined fallback");
        }
        throw error;
      }
      const Fallback = fallback;
      childrenOrFallback = /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(FallbackBoundary, { children: typeof Fallback === "function" ? /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(Fallback, { error, reset: this.reset }) : Fallback });
    }
    return /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(ErrorBoundaryContext.Provider, { value: __spreadProps(__spreadValues({}, this.state), { reset: this.reset }), children: childrenOrFallback });
  }
};
var ErrorInFallback = class extends Error {
  constructor(originalError) {
    super();
    this.originalError = originalError;
  }
};
var FallbackBoundary = class extends import_react8.Component {
  componentDidCatch(originalError) {
    throw originalError instanceof SuspensiveError ? originalError : new ErrorInFallback(originalError);
  }
  render() {
    return this.props.children;
  }
};
var ErrorBoundary = Object.assign(
  (0, import_react8.forwardRef)(
    ({ fallback, children, onError, onReset, resetKeys, shouldCatch }, ref) => {
      var _a;
      const group = (_a = (0, import_react8.useContext)(ErrorBoundaryGroupContext)) != null ? _a : { resetKey: 0 };
      const baseErrorBoundaryRef = (0, import_react8.useRef)(null);
      (0, import_react8.useImperativeHandle)(ref, () => ({
        reset: () => {
          var _a2;
          return (_a2 = baseErrorBoundaryRef.current) == null ? void 0 : _a2.reset();
        }
      }));
      return /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(
        BaseErrorBoundary,
        {
          shouldCatch,
          fallback,
          onError,
          onReset,
          resetKeys: [group.resetKey, ...resetKeys || []],
          ref: baseErrorBoundaryRef,
          children
        }
      );
    }
  ),
  {
    displayName: "ErrorBoundary",
    with: (errorBoundaryProps = { fallback: void 0 }, Component2) => Object.assign(
      (props) => /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(ErrorBoundary, __spreadProps(__spreadValues({}, errorBoundaryProps), { children: /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(Component2, __spreadValues({}, props)) })),
      { displayName: "ErrorBoundary.with(".concat(Component2.displayName || Component2.name || "Component", ")") }
    ),
    Consumer: ({ children }) => /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_jsx_runtime6.Fragment, { children: children(useErrorBoundary()) })
  }
);
var ErrorBoundaryContext = Object.assign((0, import_react8.createContext)(null), {
  displayName: "ErrorBoundaryContext"
});
var useErrorBoundary = () => {
  const [state, setState] = (0, import_react8.useState)({
    isError: false,
    error: null
  });
  if (state.isError) {
    throw state.error;
  }
  const errorBoundary = (0, import_react8.useContext)(ErrorBoundaryContext);
  SuspensiveError.assert(
    errorBoundary != null && !errorBoundary.isError,
    Message_useErrorBoundary_this_hook_should_be_called_in_ErrorBoundary_props_children
  );
  return (0, import_react8.useMemo)(
    () => ({
      setError: (error) => setState({ isError: true, error })
    }),
    []
  );
};
var useErrorBoundaryFallbackProps = () => {
  const errorBoundary = (0, import_react8.useContext)(ErrorBoundaryContext);
  SuspensiveError.assert(
    errorBoundary != null && errorBoundary.isError,
    Message_useErrorBoundaryFallbackProps_this_hook_should_be_called_in_ErrorBoundary_props_fallback
  );
  return (0, import_react8.useMemo)(
    () => ({
      error: errorBoundary.error,
      reset: errorBoundary.reset
    }),
    [errorBoundary.error, errorBoundary.reset]
  );
};

// src/Delay.tsx
var import_react9 = require("react");
var import_jsx_runtime7 = require("react/jsx-runtime");
var Delay = Object.assign(
  (props) => {
    var _a, _b;
    if (process.env.NODE_ENV === "development" && typeof props.ms === "number") {
      SuspensiveError.assert(props.ms >= 0, Message_Delay_ms_prop_should_be_greater_than_or_equal_to_0);
    }
    const defaultProps = (0, import_react9.useContext)(DelayDefaultPropsContext);
    const ms = (_b = (_a = props.ms) != null ? _a : defaultProps.ms) != null ? _b : 0;
    const [isDelayed, setIsDelayed] = (0, import_react9.useState)(ms <= 0);
    useTimeout(() => setIsDelayed(true), ms);
    if (typeof props.children === "function") {
      return /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(import_jsx_runtime7.Fragment, { children: props.children({ isDelayed }) });
    }
    if (isDelayed) {
      return /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(import_jsx_runtime7.Fragment, { children: props.children });
    }
    if (props.fallback === void 0) {
      return /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(import_jsx_runtime7.Fragment, { children: defaultProps.fallback });
    }
    return /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(import_jsx_runtime7.Fragment, { children: props.fallback });
  },
  {
    displayName: "Delay",
    with: (delayProps = {}, Component2) => Object.assign(
      (props) => /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(Delay, __spreadProps(__spreadValues({}, delayProps), { children: /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(Component2, __spreadValues({}, props)) })),
      { displayName: "Delay.with(".concat(Component2.displayName || Component2.name || "Component", ")") }
    )
  }
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ClientOnly,
  DefaultProps,
  DefaultPropsProvider,
  Delay,
  ErrorBoundary,
  ErrorBoundaryGroup,
  Suspense,
  useErrorBoundary,
  useErrorBoundaryFallbackProps,
  useErrorBoundaryGroup
});
//# sourceMappingURL=index.cjs.map